%------------------------------------------------------------------------
%|   capturaFiltros
%------------------------------------------------------------------------
%|      Script que captura todos los parmetros los filtros del RX
%-------------------------------------------------------------------------
%|   Autor: Cesar Delgado
%|   Fecha: 19-Abril-2.004
%-------------------------------------------------------------------------

% 1.- Captura de Unidades
%------------------------
aux(pFI) = get(udsRX(1,2),'value');
aux(pBB) = get(udsRX(2,2),'value');

% 2.- Captura de Valores
%------------------------
% >>>>>>>>> 2.1.- Captura y redondeo de valores
Orden(pFI) = abs(round(str2num(get(paramRX(1,1),'string'))));
set(paramRX(1,1),'string', num2str(Orden(pFI)));
Bw(pFI)    = str2num(get(paramRX(1,2),'string'));
Orden(pBB) = abs(round(str2num(get(paramRX(2,1),'string'))));
set(paramRX(2,1),'string', num2str(Orden(pBB)));
Bw(pBB)    = str2num(get(paramRX(2,2),'string'));


%>>>>>>>>>>> 2.2.- Captura Unidades de FI
if (evento==21), %%%%% Si cambiamos de unidades
    if (aux(pFI)>1), % kHz
      Bw(pFI) = Bw(pFI)*1000;
      set(paramRX(1,2),'string', num2str(fix(Bw(pFI)*1000)/1e6));   
   else,             % Hz
      set(paramRX(1,2),'string', num2str(fix(Bw(pFI)*1000)/1e3));
   end;

else,       %%%%% Si actualizamos editable
   if aux(pFI)>1,  % kHz
      Bw(pFI)=Bw(pFI)*1000; 
      set(udsRX(1,2),'value',2);
   end;
end;

% >>>>>>>>>>  2.3.- Captura Unidades de BB
if (evento==24),  %%%%% Si cambiamos de unidades
   if (aux(pBB)>1), % kHz
      Bw(pBB) = Bw(pBB)*1000;
      set(paramRX(2,2),'string', num2str(fix(Bw(pBB)*1000)/1e6));   
   else,            % Hz
      set(paramRX(2,2),'string', num2str(fix(Bw(pBB)*1000)/1e3));
   end;
else,          %%%%% Si actualizamos editable
   if aux(pBB)>1, % kHz
      Bw(pBB)=Bw(pBB)*1000; 
      set(udsRX(2,2),'value',2);
   end; 
end;



% 3.- Eleccin de unicades apropiadas
%-------------------------------------
% >>>>>>>> 3.1.- Filtro Frecuencia Intermedia
if (Bw(pFI)>10e3),
   set(paramRX(1,2),'string', num2str(fix(Bw(pFI)*1000)/1e6));
   set(udsRX(1,2),'value',2);
elseif Bw(pFI)< 1000,
   set(paramRX(1,2),'string', num2str(fix(Bw(pFI)*1000)/1000));
   set(udsRX(1,2),'value',1);   
end;

% >>>>>>>> 3.2.- Filtro Banda Base
if (Bw(pBB)>10e3),
   set(paramRX(2,2),'string', num2str(fix(Bw(pBB)*1000)/1e6));
   set(udsRX(2,2),'value',2);
elseif Bw(pBB)< 1000,
   set(paramRX(2,2),'string', num2str(fix(Bw(pBB)*1000)/1000));
   set(udsRX(2,2),'value',1);
end;


   