%------------------------------------------------------------------------
%|   capturaLab
%------------------------------------------------------------------------
%|      Script que captura los controles de la seal del laboratorio
%-------------------------------------------------------------------------
%|   Autor: Cesar Delgado
%|   Fecha: 19-Abril-2.004
%-------------------------------------------------------------------------

rutaLarga = min(ruta(length(ruta)-4:length(ruta)) == 'test\');

%%%% VEMOS SEAL DEL LABORATORIO
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if get(verSignalLab,'value'),
    
    %%%% 1.- Habilitamos Editable con ficheros propuestos
    set(fichTest,'Enable','On');
    
    %%%% 2.- Dehabilitamos botones de recepcion de texto
    set(textoIn,'Enable','Off');
    set(pulsa(:),'Enable','Off');
    set(paramTX(:),'Enable','Off');  
    set(paramRX(:),'Enable','Off'); 
    set(udsRX(udsRX>0),'Enable','Off');
    
    %%%% 3.- Editable de pto. de Observacion se conmuta
    set(ptoObsv(:,1),'Enable','Off','Visible','Off');        
    set(ptoObsv(:,2),'Enable','On' ,'Visible','On');
    
    %%%% 4.- Se deshabilitan las frecuencias del simulador
    %%%        y se establecen las requeridas
    f = [2100 2100 21000];
    set(botFrec(:),'Enable','Off');
    set(udsFrec(2:3),'Enable','Off');
    
    %%%% 5.- Agregamos al final de la ruta 'test\'
    if (~rutaLarga), ruta = [ruta 'test\']; end;
    
    %%%% 6.- Conservamos activas las graficas que estabamos viendo
    if (evento  == 50),
        estado = char((grafActivas')*'On ' + ((~grafActivas)')*'Off');      
        set(ptoObsv(1,2),'Enable', estado(1,:));    
        set(ptoObsv(2,2),'Enable', estado(2,:));
    end;   
        
    %%%%% 7.-Cargamos fichero a tratar
    opcion = get(fichTest,'Value');    
    ReceptorLab(ruta, opcion);    
    set(graf(:),'Enable','On');
    
%%%% VEMOS SEAL DEL SIMULADOR
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
else,
    
    %%%% 1.- Deshabilitamos el editable de ficheros de test
    set(fichTest,'Enable','Off');
    
    %%%% 2.- Habilitamos botones de recepcion de texto
    set(textoIn,'Enable','On');
    set(pulsa(:),'Enable','On');
    set(paramTX(:),'Enable','On');  
    set(paramRX(:),'Enable','On'); 
    set(udsRX(udsRX>0),'Enable','On');
    
    %%%% 3.- Editable de pto. de Observacion se conmuta
    set(ptoObsv(:,2),'Enable','Off','Visible','Off');    
    set(ptoObsv(:,1),'Enable','On' ,'Visible','On');
    
    %%%% 4.- Se habilitan las frecuencias del simulador 
    set(botFrec(:),'Enable','On');
    set(udsFrec(2:3),'Enable','On');   
    capturaGenerales;
    
    %%%% 5.- Quitamos del final de la ruta 'test\'
    if (rutaLarga), ruta = ruta(1:length(ruta)-5); end;
    
    %%%% 6.- Conservamos habilitadas las grafica que estabamos
    %%%%      viendo  
    if (evento==50),
      estado = char((grafActivas')*'On ' + ((~grafActivas)')*'Off');      
       set(ptoObsv(1,1),'Enable', estado(1,:));    
       set(ptoObsv(2,1),'Enable', estado(2,:));
    end;  
end;

clear aux rutaLarga lonSignal opcion estado
