function diagramaBloques(ruta, diagrama)

%------------------------------------------------------------------------
%|  function diagramaBloques(ruta, diagrama)
%------------------------------------------------------------------------
%|    Funcin que representa un diagrama de ojos. Extrae la informacion
%|  de linea de os ficheros generados tanto por el transmisor como el 
%|  receptor BPSK
%|
%|       NO REALIZA VALIDACIN DE PARMETROS DE ENTRADA
%|
%|    Entradas:
%|       1.- RUTA= ruta donde se encuentran los ficheros.
%|
%|       2.- DIAGRAMA: entero que indica el tipo de representacion a realizar
%|                   0 = diagrama de bloques del sistema
%|                   1 = diagrama de de bloques de la recuperacion de
%|                       portadora
%-------------------------------------------------------------------------
%   Autor: Cesar Delgado
%   Fecha: 19-Abril-2.004
%-------------------------------------------------------------------------

% 1.- Creamos Figura
%-------------------
figdiag=figure('Units','Normalized',...
		 'Position',[0.0525 0.083 0.87 0.87],...
		 'Number','off',...
         'Menubar','none', ...
         'Visible','Off',...
    	 'color',[0 0 0]);
     
 % 2.- Ejes donde representar imagen
 %----------------------------------
axes('Units','Normalized',...
     'Position',[0 0 1 1]);
 
 % 3.- Cargamos fichero oprtuno
 %-----------------------------
switch diagrama,
    case 0, %%%%%%%%%% DIAGRAMA DE BLOQUES DEL SISTEMA COMPLETO
        set(figdiag,'Name','Diagrama de Bloques General del Sistema BPSK');
        [x,map]=imread([ruta 'general.jpg'],'jpg');
    case 1, %%%%%%%%%% DIAGRAMA DE BLOQUES DE LA RECUPERACION DE PORTADORA
        set(figdiag,'Name','Diagrama de Bloques de la Recuperacion de Portadora del demodulador BPSK');
        [x,map]=imread([ruta 'portadora.jpg'],'jpg');
    otherwise, %%%%%%%%%% DIAGRAMA DE BLOQUES DEL SISTEMA COMPLETO
        set(figdiag,'Name','Diagrama de Bloques General del Sistema BPSK');
        [x,map]=imread([ruta 'general.jpg'],'jpg');
end;

 % 4.- Realizamos la representacion
 %---------------------------------
 image(x), colormap(map), axis off
 set(figdiag,'Visible','On');
 