function eje=enfocaEje(grafActivas, actSup)

%------------------------------------------------------------------------
%|   enfocaEje(grafActivas, sup)
%------------------------------------------------------------------------
%|   Funcin que enfoca uno de los ejes de representacin. 
%|
%|       Debido a la reiteracin de esta accin, es conveniente
%|   introducirla en una funcin. As, se pueden cambian 
%|   las dimensiones de los ejes sin problemas de compatibilidad
%|   entre enfoques realizados por distintas funciones
%|
%|  Entradas:
%|         1.- GRAF_ACTIVAS= vector fila de dos elementos.
%|                           [Activa Graf. Sup., Activa Graf. Inf.]
%|         2.- ACT_SUP     = Se actualiza grfica superior(=1) o inferior(=0)
%|
%-------------------------------------------------------------------------
%|   Autor: Cesar Delgado
%|   Fecha: 19-Abril-2.004
%-------------------------------------------------------------------------

gSUP = 1;
gINF = 2;
% 1.- Enfoque de ejes
%--------------------
if grafActivas(gSUP) & grafActivas(gINF),   
   % 1.1.- Las dos grficas estn activadas
   switch actSup,       
       case 0, % Actualizamos grafica inferior
           eje=subplot('position',[0.065, 0.12, 0.6, 0.343902]);           
       case 1, % Actualizamos grafica Superior
           eje=subplot('position',[0.065, 0.59, 0.6, 0.343902]);           
       case 3, % Representacion de 1/4 inferior iqdo.
           eje=subplot('position',[0.075, 0.12, 0.25, 0.343902]);
       case 4, % Representacion de 1/4 inferior drcho.
           eje=subplot('position',[0.401, 0.12, 0.25, 0.343902]);            
   end;  
else
   % 1.2.- Solo est activa una grfica 
   eje=subplot('position',[0.065, 0.14, 0.6, 0.75]); 
end;

   
