%------------------------------------------------------------------------
%|  	validaGenerales
%------------------------------------------------------------------------
%|      Script que genera todos los controles del marco de parmetros
%|   generales.
%------------------------------------------------------------------------
%|   Autor: Cesar Delgado
%|   Fecha: 19-Abril-2.004
%------------------------------------------------------------------------

% 1.- Lmites al Rgimen Binario: [10 , 10e3]
%---------------------------------------------
if (f(pRB) > 1e4) | (f(pRB) < 10), f(pRB)=2^11; end;

% 2.- Validacin de Frecuencias: 
%      a) FI = k*RB, siendo k=2,3,...
%      b) FS = m*FI, siendo m=2,3,...
%---------------------------------------------
[f(pFS), f(pFI)] = validaFrec(f(pFS),f(pFI),f(pRB));


% 3.- Ponemos los nuevos valores en Editables
%--------------------------------------------
%   3.1.- Frecuencia Intermedia
aux = get(udsFrec(pFI),'value');
if aux>1,
   set(botFrec(pFI),'String',num2str(f(pFI)/1e3));
end;

%   3.2.- Frecuencia de Muestreo
aux = get(udsFrec(pFS),'value');
if aux>1,
   set(botFrec(pFS),'String',num2str(f(pFS)/1e3));
end;

%   3.3.- Regimen Binario
set(botFrec(pRB),'String',num2str(f(pRB)));

% 4.- Eliminamos variables intiles
%----------------------------------
clear aux
