function tramas = ReceptorLab(ruta, opcion)
%------------------------------------------------------------------------
%|  function tramas = ReceptorLab(ruta, opcion)
%------------------------------------------------------------------------
%|     
%|    Entradas:
%|       1.- RUTA    = string con el path del fichero de entrada.
%|       2.- OPCION  = entero que especifica el fichero de test:
%|              1 = 'test1.mat'
%|              2 = 'test2.mat'
%|              3 = 'test3.mat'
%|              4 = 'test4.mat'
%|
%|     NOTA: requiere Toolbox de Comunicaciones
%|
%-------------------------------------------------------------------------
%|   Autor: Cesar Delgado
%|   Fecha: 19-Abril-2.004
%-------------------------------------------------------------------------

if nargin < 1,
    error('ERROR: falta la ruta en ReceptorLab()');
else,
    
%%%%%%%%%%%% Definicin de Ctes.
pENTRE   = 1; pFILA   = 1; pCOL    = 2;
pCRC     = 2; pTRAMO  = 1; pCODE   = 2;
fINFO    = 0; fTRAMA  = 1; fSIGNAL = 2;
parametros = [14, 10; 7, 4]; 
metodo     = 'hamming';

%##########################################################################
% 1.- NIVEL FSICO DEL RECEPTOR:
%         a) Demodulacin
%         b) Recuperacin de Reloj
%##########################################################################
  nivFisicoLab;

%##########################################################################
% 2.- NIVEL ENLACE DEL RECEPTOR:
%         a) Desentrelazado
%         b) Recuperacin CRC (Cdigo de Redundancia Cclica)
%##########################################################################
  nivEnlaceRX;

%##########################################################################
% 3.- NIVEL PRESENTACIN DEL RECEPTOR:
%        De binario a ASCII
%##########################################################################
  nivPresenRX;  

end; 