function PAM = GeneraPAM (IN, L)
%------------------------------------------------------------------------
%  function PAM = GeneraPAM (IN, L)
%------------------------------------------------------------------------
%    Funcion que genera una PAM dada una secuencia de bits de entrada
%   suponiendo que siempre exite un muestreo de L veces el Regimen
%   Binario de la seal de salida
%   
%    Entradas:
%       1.- IN = secuencia de ceros y unos
%       2.- L  = N muestras/pulso
%
%    Salida:
%       1.- PAM =  seal de linea TTL
%-------------------------------------------------------------------------
%   Autor: Cesar Delgado
%   Fecha: 19-Abril-2.004
%-------------------------------------------------------------------------

if nargin < 1
    disp('ERROR: minimo un parametro de entrada en la funcion GeneraPAM');         
else
    if nargin < 2   
         L = 10;           
    end;        

    % 1.- Interpolacion
    %-------------------
    inter(1:L:L*length(IN)) = IN;
    
    % 2.- Determinacion de la PAM
    %----------------------------
    h   = ones(1,L); 
    PAM = conv(inter,h);     
end;